! Collects acceleration, rotation, and magnetic field
! strength for a specified period of time, then writes
! the data to a file for later analysis.
!
! The variables at the start of the program control
! the sample rate and time.
!
! See these programs for a way to plot the data:
!     Plot Acceleration.bas
!     Plot Gyroscope.bas
!     Plot Magnetometer.bas
!
! Author: Mike Westerfield
! Date: October 2011
! Written in techBASIC 1.0.2
! This source code is released to the public domain.

! Sample rate.
rate = 0.1

! Sample time in seconds; rate/time must be <= 2730.
time = 270

! Output file name.
name$ = "mydata.bin"

! Collect accelerometer, magnetometer & gyroscope data.
samples = int(time/rate)
a = sensors.sample(7, rate, samples)

! Write the values to the data file.
open name$ for output as #1
for s = 1 to samples
  for d = 1 to 12
    put #1,, a(s, d)
next d, s

! Print a message indicating successful recording.
print samples; " samples written to "; name$; "."